<?php
defined('IN_COPPERMINE') or die('Not in Coppermine...');

if (!GALLERY_ADMIN_MODE) {
	cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
}

if ($superCage->post->keyExists('submit')) {
	thumbplus_process_form();
}

thumbplus_display_form();

/***************************************************************************/

function thumbplus_display_form ()
{
	global $CONFIG, $lang_common, $lang_gallery_admin_menu, $lang_plugin_thumbplus;

	starttable('100%', $lang_plugin_thumbplus['thumbplus']." - ".$lang_gallery_admin_menu['admin_lnk'], 1);

	$rslt = cpg_db_query("SELECT scope, cfg FROM {$CONFIG['TABLE_PREFIX']}plugin_thumbplus");
	$rows = cpg_db_fetch_rowset($rslt, true);
	$cfgs = [];
	foreach ($rows as $row) {
		$cfgs[$row['scope']] = $row['cfg'];
	}

	$submit_icon = cpg_fetch_icon('ok', 1);

	$scopes = json_decode($CONFIG['thumbplus_cfg'], true);

	echo <<<EOT
	<tr>
		<td class="tableb">
		<div class="thmpcfgs">
EOT;
	foreach ($scopes as $K => $E) {
		if (isset($cfgs[$K])) {
			$cfg = json_decode($cfgs[$K]);
		} else {
			$cfg = (object) array('rplall'=>false,'html'=>'');
		}
		$eckd = $E ? ' checked="checked"' : '';
		$ackd = $cfg->rplall ? ' checked="checked"' : '';
		$hc = $E ? '' : ' class="disab"';
		echo <<<EOT
		<div id="thmp_cfg_{$K}">
			<div>
				<input type="checkbox" class="fcheckbox" name="enab[]" id="enab_{$K}" value="{$K}" onchange="showCfg(this)"{$eckd}>
				<span style="text-transform:uppercase;font-weight:bold"> {$K}</span>
				<!-- {$lang_plugin_thumbplus['enabled']} -->
			</div>
			<div{$hc}>
				<div>
					{$lang_plugin_thumbplus['html']}
					<textarea name="html_{$K}" style="width:90%;height:40px">{$cfg->html}</textarea>
				</div>
				<div style="margin-bottom:1em">
					<input type="checkbox" class="fcheckbox" name="rplall_{$K}" id="rplall_{$K}" value="1"{$ackd}>
					{$lang_plugin_thumbplus['rplall']}
				</div>
			</div>
		</div>
EOT;
	}
	echo <<<EOT
		</div>
		</td>
	</tr>
	<tr>
		<td class="tableb" style="text-align:center">
			<br /><button value="{$lang_common['apply_changes']}" name="submit" class="button" type="submit">{$submit_icon}{$lang_common['apply_changes']}</button>
		</td>
	</tr>
EOT;
	endtable();
}

function thumbplus_process_form ()
{
	global $CONFIG, $superCage, $lang_common, $lang_plugin_thumbplus;

	$dbtbl = $CONFIG['TABLE_PREFIX'].'plugin_thumbplus';

	$scopes = json_decode($CONFIG['thumbplus_cfg'], true);
	$enabs = $superCage->post->keyExists('enab') ? $superCage->post->getRaw('enab') : [];
	foreach ($scopes as $K => $E) {
		$scopes[$K] = in_array($K, $enabs) ? 1 : 0;
		$cfg = [];
		$cfg['rplall'] = $superCage->post->keyExists('rplall_'.$K);
		$cfg['html'] = $superCage->post->getRaw('html_'.$K);
		$cfj = json_encode($cfg);
		$cf = cpg_db_real_escape_string($cfj);
		$sql = "SELECT cfg FROM {$dbtbl} WHERE scope='{$K}'";
		$rslt = cpg_db_query($sql);
		if (cpg_db_num_rows($rslt)) {
			$c = $rslt->result(0, 0, true);
			if ($c != $cfj) {
				$sql = "UPDATE {$dbtbl} SET cfg = \"{$cf}\" WHERE scope='{$K}'";
				cpg_db_query($sql);
			}
		} else {
			$sql = "INSERT INTO {$dbtbl} VALUES ('{$K}','{$cf}')";
			cpg_db_query($sql);
		}
	}

	cpg_config_set('thumbplus_cfg', json_encode($scopes), true);

	msg_box('', $lang_plugin_thumbplus['saved'], '', '', 'success');
}
