<?php
defined('IN_COPPERMINE') or die('Not in Coppermine...');

class ThumbPlus
{
	protected $cfg, $m;
	protected $oids = [];
	protected $albs = [];
	protected $ufld = null;
	protected $stars = [];

	public function __construct ($scope)
	{
		global $CONFIG;
		$c = cpg_db_query("SELECT cfg FROM {$CONFIG['TABLE_PREFIX']}plugin_thumbplus WHERE scope='{$scope}'")->result(0, 0, true);
		$this->cfg = json_decode($c);
		preg_match_all('|{([^}]*)}|', $this->cfg->html, $this->m);
	}

	public function process (&$rowset)
	{
		global $CONFIG, $THEME_DIR, $lang_date, $cpg_udb;	//echo'<xmp>';var_dump($rowset[0]);echo'</xmp>';
		foreach ($rowset as $k => $row) {
			$sss = preg_replace('/\R/','',$this->cfg->html);
			foreach ($this->m[0] as $j => $ms) {
				$rpl = '';
				$ps = explode('|',$this->m[1][$j]);
				$pf = trim($ps[0]);
				switch ($pf) {
				case 'caption':
					$rpl = strip_tags(bb_decode($row['caption']));
					break;
				case 'ctime':
					$rpl = localised_date($row['ctime'], isset($ps[1]) ? $ps[1] : $lang_date['lastup']);
					break;
				case 'mtime':
					$rpl = localised_date($row['mtime'], isset($ps[1]) ? $ps[1] : $lang_date['lasthit']);
					break;
				case 'filesize':
					$rpl = cpg_format_bytes($row['filesize']);
					break;
			//	case 'owner_id':
				case 'owner':
					$o = $row['owner_id'];
					if ($o) {
						if (!isset($this->oids[$o])) {
							$this->oids[$o] = $cpg_udb->get_user_name($o);
						}
						$rpl = $this->oids[$o];
					}
					break;
				case 'album':
					$a = $row['aid'];
					if ($a) {
						if (!isset($this->albs[$a])) {
							$this->albs[$a] = get_album_name($a)['title'];
						}
						$rpl = $this->albs[$a];
					}
					break;
				case 'pic_rating':
					$sc = $CONFIG['rating_stars_amount'];
					if (!$this->stars) {
						$pfx = defined('THEME_HAS_RATING_GRAPHICS') ? $THEME_DIR : '';
						$sf = '<img src="'.$pfx. 'images/rate_full.png" alt=""/>';
						$se = '<img src="'.$pfx. 'images/rate_empty.png" alt=""/>';
						for ($i=0; $i<=$sc; $i++) {
							$strz = str_repeat($sf, $i);
							$strz .= str_repeat($se, $sc-$i);
							$this->stars[$i] = $strz;
						}
					}
					$r = round(($row['pic_rating'] / 2000) / (5 / $sc));
					$rpl = $this->stars[$r];
					break;
				default:
					if (isset($row[$pf])) {
						$rpl = $row[$pf];
					} else {
						if (is_null($this->ufld)) {
							$this->ufld = [];
							for ($i=1; $i<7; $i++) {
								$ufn = $CONFIG['user_field'.$i.'_name'];
								if (!empty($ufn)) $this->ufld[$ufn] = 'user'.$i;
							}
						}
						if (isset($this->ufld[$pf])) $rpl = $row[$this->ufld[$pf]];
					}
				}
				$sss = str_replace($ms, $rpl, $sss);
			}
			if ($this->cfg->rplall) {
				$rowset[$k]['caption_text'] = $sss;
			} else {
				$rowset[$k]['caption_text'] .= $sss;
			}
		}
	}

}
